var foxampPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

if (foxampPrefs.getPrefType("foxamp.update.value") == foxampPrefs.PREF_INVALID){
	foxampPrefs.setIntPref("foxamp.update.value", 5);	
}



if (foxampPrefs.getPrefType("foxamp.scrolltitle.enable") == foxampPrefs.PREF_INVALID){
	foxampPrefs.setBoolPref("foxamp.scrolltitle.enable", true);	
}



if (foxampPrefs.getPrefType("foxamp.scrolltitle.value") == foxampPrefs.PREF_INVALID){
	foxampPrefs.setIntPref("foxamp.scrolltitle.value", 500);	
}



if (foxampPrefs.getPrefType("foxamp.winampautostart") == foxampPrefs.PREF_INVALID){
	foxampPrefs.setBoolPref("foxamp.winampautostart", true);	
}



if (foxampPrefs.getPrefType("foxamp.winampdir") == foxampPrefs.PREF_INVALID){
	foxampPrefs.setCharPref("foxamp.winampdir", "");	
}

var winampCurrentVolume = 255; /* from 0(min) to 255(max), start with max */

function winampChangeVolume (outputNewVolume) {
	if (outputNewVolume == "PLUS") {
		winampCurrentVolume = winampCurrentVolume + 5;
		if (winampCurrentVolume > 255) {
			winampCurrentVolume = 255;
		}
	} else if (outputNewVolume == "MINUS") {
		winampCurrentVolume = winampCurrentVolume - 5;
		if (winampCurrentVolume < 0) {
			winampCurrentVolume = 0;
		}
	} else {
		winampCurrentVolume = outputNewVolume;
	}
	
	/* ::: Fix the directory service and local file interface for the volume program ::: */
	var directoryServiceVolumeChanger=Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
	var winampExecuteVolumeProgram = directoryServiceVolumeChanger.get('ProfD',Components.interfaces.nsILocalFile);
                                       	
	/* ::: Define the path to the exe ::: */
	winampExecuteVolumeProgram.append("extensions");
	winampExecuteVolumeProgram.append("{F0B24ABB-A42D-4c82-AF2C-3FA6FF27E2C0}");
	winampExecuteVolumeProgram.append("fa_special.exe");

	/* ::: Inititate the process ::: */
	var winampVolumeProgramProcess = Components.classes["@mozilla.org/process/util;1"]
                           		.getService(Components.interfaces.nsIProcess);
	try {
		winampVolumeProgramProcess.init(winampExecuteVolumeProgram);
	}
	catch (e) { }
	
	/* ::: run with the value as a parameter ::: */
	var foxampVolumeArray= new Array(2);
	foxampVolumeArray[0]="/VOL";
	foxampVolumeArray[1]=winampCurrentVolume;

	winampVolumeProgramProcess.run(false,foxampVolumeArray,2);
}

var winampOldSongtitle;

function winampExecute( winampCommandExe )
{

	/* ::: Fix the directory service and local file interface to the winampcc executable ::: */
	var directoryService=Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
	var winampFile = directoryService.get('ProfD', Components.interfaces.nsILocalFile);
                                       	
	/* ::: Define the path do the exe ::: */
	winampFile.append("extensions");
	winampFile.append("{F0B24ABB-A42D-4c82-AF2C-3FA6FF27E2C0}");
	winampFile.append("fa_special.exe");

	/* ::: Inititate the process ::: */
	var winampProcess = Components.classes["@mozilla.org/process/util;1"].getService(Components.interfaces.nsIProcess);

	try {
		winampProcess.init(winampFile);
	}
	catch (e) { }
	
	/* ::: Just do it.. :) ::: */
	
	var foxampPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var foxampSettingWinampAutostart = foxampPrefs.getBoolPref("foxamp.winampautostart");
	var foxampSettingWinampDir = foxampPrefs.getCharPref("foxamp.winampdir");
	
	if (foxampSettingWinampAutostart == true) {
		var foxampExecuteArray= new Array(2);
		foxampExecuteArray[0]=foxampSettingWinampDir + "\\winamp.exe";
		foxampExecuteArray[1]=winampCommandExe;
		
		winampProcess.run(false,foxampExecuteArray,2);
	} else {
	
		winampProcess.run(false,[winampCommandExe],1);
	
	}

}

function winampSaveSongticker () {

	/* ::: Fix the directory service and local file interface for the songtitle program ::: */
	var directoryServiceSaveSongticker=Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
	var winampSaveSongtickerFile = directoryServiceSaveSongticker.get('ProfD',Components.interfaces.nsILocalFile);
                                       	
	/* ::: Define the path to the exe ::: */
	winampSaveSongtickerFile.append("extensions");
	winampSaveSongtickerFile.append("{F0B24ABB-A42D-4c82-AF2C-3FA6FF27E2C0}");
	winampSaveSongtickerFile.append("fa_special.exe");

	/* ::: Inititate the process ::: */
	var winampSaveSongtickerProcess = Components.classes["@mozilla.org/process/util;1"].getService(Components.interfaces.nsIProcess);

	try {
		winampSaveSongtickerProcess.init(winampSaveSongtickerFile);
	}
	catch (e) { }
	
	/* ::: runt with parameter -x = save to file ::: */
	winampSaveSongtickerProcess.run(false,["-x"],1);
	
	setTimeout(winampLoadSongticker, 500); // Load songticker file.
	
	var foxampPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var foxampSettingUpdate = foxampPrefs.getIntPref("foxamp.update.value");
	
	foxampSettingUpdate = foxampSettingUpdate * 1000;
	
	setTimeout(winampSaveSongticker, foxampSettingUpdate); // Redo this function.
}

window.setTimeout(winampSaveSongticker, 1000);

function winampLoadSongticker () {

	/* ::: Fix the directory service and local file interface to load the songtitle textfile ::: */
	var directoryServiceSongticker=Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
	var obj_FileSongTicker = directoryServiceSongticker.get('ProfD', Components.interfaces.nsILocalFile);
											
	/* ::: Define the path to songtotle.txt ::: */
	obj_FileSongTicker.append("extensions");
	obj_FileSongTicker.append("{F0B24ABB-A42D-4c82-AF2C-3FA6FF27E2C0}");
	obj_FileSongTicker.append("songtitle.txt");

	/*
		Thanks goes to Andreas @ http://xul.andreashalter.ch/ for this load-local-file code:
		Thanks! ;)
	*/
	var obj_InputStream =  Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
	obj_InputStream.init(obj_FileSongTicker,0x01,0444,null);
		
	var obj_ScriptableIO = Components.classes["@mozilla.org/intl/converter-input-stream;1"].createInstance(Components.interfaces.nsIConverterInputStream);
	obj_ScriptableIO.init(obj_InputStream, "UTF-16", 1024, 0xFFFD);

	var str = "";
	var data = {};
	while (obj_ScriptableIO.readString(4096, data)) {
		str += data.value;
	}

	obj_ScriptableIO.close();
	obj_InputStream.close();

	//alert(str); // Used in development to display the title in an alertbox.
			
	if (winampOldSongtitle == str) {
		// moved the ticker-code too another function...
	} else {
		winampOldSongtitle = str
		var winampUpdateSongTickerFld = document.getElementById("statusbar-winamp-songticker");
		if (str.length > 40) {
			winampUpdateSongTickerFld.label = str + " - ";
			// winampUpdateSongTickerFld.tooltiptext = str; <- doesn't seam to work, what am i doing wrong?
		} else {
			winampUpdateSongTickerFld.label = str;
		}
	}

}


function winampTickSongName () {

	var foxampPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var foxampSettingSongtickerEnable = foxampPrefs.getBoolPref("foxamp.scrolltitle.enable");
		
	if (foxampSettingSongtickerEnable == true) {

		var winampSongTickerFld = document.getElementById("statusbar-winamp-songticker");

		var winampTempName;
		winampTempName = winampSongTickerFld.label;	
		
		if (winampTempName.length > 40) {
			winampTempName = winampTempName + winampTempName.substring(0, 1); //winampSongTickerFld.length
			winampTempName = winampTempName.substring(1);
			winampSongTickerFld.label = winampTempName;
		}
		
	}
		
	var foxampSettingSongtickerValue = foxampPrefs.getIntPref("foxamp.scrolltitle.value");
	
	setTimeout(winampTickSongName, foxampSettingSongtickerValue); // "Tick" the track name..
}

window.setTimeout(winampTickSongName, 1000);
